Open Syobon Action
==================
###### by Mathew Velasquez
###### fork by Karen Tsai (angelXwind)
#### [English] [[日本語]](リードミー.md)

Open Syobon Action (オーペンしょぼんのアクション) is an open-source cross-platform port of the unforgiving Japanese platformer using SDL.

It is also called "Shobon no Action," "Neko Mario," "Cat Mario," or "Cat MeOUCHio."

Notes
-----
* When you are playing this game, there is a possibility that you will develop trust issues towards game developers.
* There is also a possibility of getting stressed out over playing this game.
* If any problems are caused by this game, the developers take no resposibility.
* If you want to distribute this game to a large amount of people, please inform the developers so that they can seek appropriate shelter.
* After you've played this game, give it to someone else who's never played it before. Then laugh.
* The game's text is entirely in Japanese, but you do not need to understand the Japanese language in order to play.

Controls (Keyboard)
-------------------
* Left, Right - Move
* Down - Enter warp pipe
* Z, Up, Semicolon - Jump
* Space - Double-speed
* Escape - Exit
* F1 - Return to title screen
* 1-9 at the title screen - Select level
* 0 at the title screen - Dungeon of curiosity (there might be... bugs :P)

Bugs
----
Please report any bugs at the GitHub issue tracker: https://github.com/angelXwind/OpenSyobonAction/issues

Command Line Arguments
----------------------
`-nosound` - Disables sound

Dependencies
------------
* SDL
* SDL_image
* SDL_mixer
* SDL_ttf
* SDL_gfx

Gamepad Notes
-------------
Your gamepad or joystick may not work by default with Open Syobon Action. Check joyconfig.h for more information.

Unimplemented
-------------
* Font thickness (Not really important)
* Port to other operating systems (OS X, iOS, Android, etc.)

Release Changelog
-----------------
**Open Syobon Action RC 2 r2 (angelXwind fork)**
* Reformatted the README to include information previously only available in the original Japanese version.

**Open Syobon Action RC 2 r1 (angelXwind fork)**
* Fixed audio on Windows 7 and above

**Open Syobon Action RC 2**
* First Windows release!
* Dvorak keyboard support
* Error messages more detailed and directed to stdout
* Compiled code optimized for speed
* Better initialization and de-initialization code, so you can be confident
 that all resources are freed.
* Optional sound: The game will no longer crash if there is no audio device
 available, and all sound can be disabled with the -nosound parameter
* Minor bugfixes here and there

**Open Syobon Action RC 1**
* Fixed incorrect "box" rendering (used to draw green pipes)
* Fixed random crashing at certain parts (thanks to mekuso for the bug report)
* Volumes now appropriately altered
* Gamepad support added
* Now uses original indexed PNGs, with original filenames (capital PNG)
* Minor tweaks and optimizations

**Open Syobon Action v0.9:**
* Fixed incorrect character rendering, uses font very similar to the original game
 (sazanami-gothic.ttf rather than msgothic.ttf)
* Changed encoding of the original readme and source code to UTF-8, so they can
 be viewed correctly with most software
* Changed DOS newlines to Unix newlines in source and readme
* Source code has been cleaned up with "indent", removed a few obsolete comments

**Open Syobon Action v0.8:**
* First release